#include "stdafx.h"
#include "FTState.h"
#include "FTStateSend.h"
#include "Resource.h"
#include "UIChatFileElement.h"

namespace FileTransferState {

	//---------------------------------------
	// implementation of CFTStateSendBase
	// 

	CFTStateSendBase::CFTStateSendBase(UIChatFileElement * pUIElem)
		:CFTState(pUIElem)
	{
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();
		int nDisplayType = pResource->GetChatDisplayType();

		if ( nDisplayType == CHAT_BUBBLE)
		{
			m_alignmentFileName = StringAlignmentNear;
			m_alignmentButton[Button_General] = StringAlignmentNear;
			m_alignmentProgress = StringAlignmentNear;
		}
		else
		{
			m_alignmentFileName = StringAlignmentNear;
			m_alignmentButton[Button_General] = StringAlignmentNear;
			m_alignmentProgress = StringAlignmentNear;
		}
		//m_alignmentButton[Button_General] = StringAlignmentFar;
		//m_alignmentProgress = StringAlignmentFar;
		m_bWillDisplayFileSize = TRUE;
	}


	void CFTStateSendBase::_SetControlPos(const CPoint& ptPos, CSize& sz, DWORD dwFlags)
	{
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		PointF ptOffset((REAL)ptPos.x, (REAL)ptPos.y);

		CRect rc_view = pResource->GetViewRect();
		int nDisplayType = pResource->GetChatDisplayType();
		if (CHAT_BUBBLE == nDisplayType)
		{
			m_rcFileIcon.X = rc_view.right - 10;
			m_rcFileIcon.Y = ptOffset.Y;

			//m_rcFileName.X = m_rcFileIcon.GetRight() + GetCurrentLayout(nDisplayType).recv().filename_to_icon_left;
			//m_rcFileName.Y = m_rcFileIcon.Y + GetCurrentLayout(nDisplayType).recv().filename_to_icon_top;

			//m_rcFileName.Width = rc_view.Width() - DEF_ITEM_POS_RIGHT_REL_X - GetCurrentLayout().recv().filename_to_item_right - m_rcFileName.X;

			/*m_rcProgress.X = m_rcFileName.X;
			m_rcProgress.Y = m_rcFileName.Y + m_rcFileName.Height + GetCurrentLayout(nDisplayType).recv().progress_to_filename_top;

			m_rcProgressExtraStatus.X = m_rcProgress.GetRight();
			m_rcProgressExtraStatus.Y = m_rcProgress.GetTop();

			//if (!m_strProgressExtraStatus.IsEmpty())
			//{
			//	//just plain translating
			//	m_rcProgressExtraStatus.X += 4;
			//}

			if (m_bShowDivider)
			{
				m_rcDivider.X = m_rcProgressExtraStatus.GetRight() + GetCurrentLayout(nDisplayType).common().divider_to_progressOrStatus_left;
				m_rcDivider.Y = m_rcProgressExtraStatus.Y + GetCurrentLayout(nDisplayType).common().divider_height_offset;
				m_rcButton[Button_General].X = m_rcDivider.GetRight() + GetCurrentLayout(nDisplayType).common().button_to_divider_left;
			}
			else
			{
				m_rcButton[Button_General].X = m_rcProgress.GetRight();
				if (m_rcProgress.Width > 0)
				{
					m_rcButton[Button_General].X += GetCurrentLayout(nDisplayType).send().cancel_to_progress_right;
				}
			}
			//m_rcButton[Button_General].X = m_rcProgress.GetRight() + GetCurrentLayout().recv().button_to_progress_right;
			m_rcButton[Button_General].Y = m_rcProgress.Y;

			sz.cy += m_rcFileIcon.Height;*/
		}
		else if(CHAT_PLAIN == nDisplayType)
		{
			m_rcFileIcon.X = ptOffset.X /*+ GetCurrentLayout(nDisplayType).send().icon_to_item_left*/;
			m_rcFileIcon.Y = ptOffset.Y /*+ GetCurrentLayout(nDisplayType).send().icon_to_item_top*/;

			m_rcFileName.X = m_rcFileIcon.GetRight() + GetCurrentLayout(nDisplayType).recv().filename_to_icon_left;
			m_rcFileName.Y = m_rcFileIcon.Y + GetCurrentLayout(nDisplayType).recv().filename_to_icon_top;

			//m_rcFileName.Width = rc_view.Width() - DEF_ITEM_POS_RIGHT_REL_X - GetCurrentLayout().recv().filename_to_item_right - m_rcFileName.X;

			m_rcProgress.X = m_rcFileName.X;
			m_rcProgress.Y = m_rcFileName.Y + m_rcFileName.Height + GetCurrentLayout(nDisplayType).recv().progress_to_filename_top;


			m_rcProgressExtraStatus.X = m_rcProgress.GetRight();
			m_rcProgressExtraStatus.Y = m_rcProgress.GetTop();

			//if (!m_strProgressExtraStatus.IsEmpty())
			//{
			//	//just plain translating
			//	m_rcProgressExtraStatus.X += 4;
			//}

			if (m_bShowDivider)
			{
				m_rcDivider.X = m_rcProgressExtraStatus.GetRight() + GetCurrentLayout(nDisplayType).common().divider_to_progressOrStatus_left;
				m_rcDivider.Y = m_rcProgressExtraStatus.Y + GetCurrentLayout(nDisplayType).common().divider_height_offset;
				m_rcButton[Button_General].X = m_rcDivider.GetRight() + GetCurrentLayout(nDisplayType).common().button_to_divider_left;
			}
			else
			{
				m_rcButton[Button_General].X = m_rcProgress.GetRight();
				if (m_rcProgress.Width > 0)
				{
					m_rcButton[Button_General].X += GetCurrentLayout(nDisplayType).send().cancel_to_progress_right;
				}
			}
			m_rcButton[Button_General].Y = m_rcProgress.Y;
	
			sz.cy = GetCurrentLayout(nDisplayType).recv().icon_to_item_top + m_rcFileIcon.Height + GetCurrentLayout(nDisplayType).recv().icon_to_item_bottom;
		}
	}

	void CFTStateSendBase::_CalcFileNameSize(const CPoint& ptOffset)
	{
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();
		int nChatType = pResource->GetChatDisplayType();
		const commonInfo& cmmInfo = GetCurrentLayout(nChatType).common();
		const sendInfo&  send = GetCurrentLayout(nChatType).send();
		CRect rcRect = pResource->GetViewRect();
		m_clrFileName = GetCurrentLayout(nChatType).send().filename_color;
		if(CHAT_BUBBLE == nChatType)
		{
			int nWidth = rcRect.Width() - _GetBubbleImage(TRUE, 0)->GetWidth() - _GetBubbleImage(TRUE, 2)->GetWidth()
				- DEF_CHAT_MSG_BUBBLE_ARROR_RIGHT_X;

			if(nWidth < m_nBubble_Inner_width_min)
			{
				nWidth = m_nBubble_Inner_width_min;
			}
			RectF rcFDraw(0.0, 0.0, nWidth, 1000.0);
			CRect rcDraw(0, 0, nWidth, 1000);
			CString strDisplayFileName = _CalcDisplayFileNameString(rcFDraw);

			CSize szBound( 0, 0);
			REAL fontHeight = 8;
			RecalcTextRectVert(pResource->GetCurrentWnd(), strDisplayFileName, g_defaultFontFaceName, fontHeight, 
				FontStyleRegular, rcDraw, szBound);

			m_BubbleInnerWidth = (REAL)szBound.cx;

			m_rcFileName.X = 0.0f;
			if(m_BubbleInnerWidth < m_nBubble_Inner_width_min)
			{
				m_BubbleInnerWidth = m_nBubble_Inner_width_min;
				m_rcFileName.X += (m_BubbleInnerWidth - (int)szBound.cx) / 2;
			}

			m_rcFileIcon.Width = m_BubbleInnerWidth + _GetBubbleImage(FALSE, 0)->GetWidth() + _GetBubbleImage(FALSE, 2)->GetWidth();
				/*((int)m_rcFileName.Width + (int)_GetBubbleImage(FALSE, 0)->GetWidth()
				+ (int)_GetBubbleImage(FALSE, 2)->GetWidth() - (int)m_rcFileIcon.Width) / 2;*/
			m_rcFileIcon.Height = cmmInfo.icon_file_type_height + cmmInfo.GetFileIconEdgeY() + 
				cmmInfo.filename_to_fileicon_top + (REAL)szBound.cy + 
				cmmInfo.GetFileNameInnerEdgeY() + _GetBubbleImage(TRUE, 6)->GetHeight();

			m_rcFileIcon.X = rcRect.Width() - 10 - m_rcFileIcon.Width;
			m_rcFileName.X += m_rcFileIcon.X + _GetBubbleImage(TRUE, 0)->GetWidth();
			m_rcFileName.Y = m_rcFileIcon.Y + cmmInfo.icon_file_type_height + cmmInfo.GetFileIconEdgeY() +
				send.filename_to_icon_top;

			m_rcFileName.Width = (REAL)szBound.cx;
			m_rcFileName.Height = (REAL)szBound.cy;
		}
		else
		{

			int nWidth = rcRect.Width() - cmmInfo.GetFileIconWidth() - ptOffset.x - send.filename_to_icon_left - send.filename_to_item_right;
			RectF rcDraw(0.0, 0.0, nWidth, cmmInfo.font_height);
			CString strDisplayFileName = _CalcDisplayFileNameString(rcDraw);
			CSize szText = _CalcTextSize(strDisplayFileName, ptOffset, cmmInfo.font_height);
			m_rcFileName.Width = (REAL)szText.cx;
			m_rcFileName.Height = (REAL)szText.cy;// GetCurrentLayout().common().filename_fontheight_offset;

		}
	}

	void CFTStateSendBase::_InitControlValue()
	{
		int nDisplayType = m_pUIChatFileElement->GetElementResource()->GetChatDisplayType();
		m_clrButtonText[Button_General] = GetCurrentLayout(nDisplayType).common().clr_text_normal;
		if (nDisplayType == CHAT_BUBBLE)
		{
			m_alignmentFileName = StringAlignmentNear;
			m_alignmentButton[Button_General] = StringAlignmentNear;
			m_alignmentProgress = StringAlignmentNear;
		}
		else
		{
			
			m_alignmentFileName = StringAlignmentNear;
			m_alignmentButton[Button_General] = StringAlignmentNear;
			m_alignmentProgress = StringAlignmentNear;
		}
		//m_alignmentButton[Button_General] = StringAlignmentFar;
		//m_alignmentProgress = StringAlignmentFar;
		m_bWillDisplayFileSize = TRUE;
	}

	void CFTStateSendBase::_CalcFileIconSize( const CPoint& ptOffset )
	{
		if(m_pUIChatFileElement->GetElementResource()->GetChatDisplayType() == CHAT_PLAIN)
		{
			CFTState::_CalcFileIconSize( ptOffset );
		}
	}

	Image* CFTStateSendBase::_GetBubbleImage( BOOL bMine, int nIndex )
	{
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		if(bMine && nIndex > 5 && nIndex < 9)
		{
			return pResource->GetBubbleBottomForSendProcessImage(nIndex - 6);
		}

		return CFTState::_GetBubbleImage(bMine, nIndex);
	}


	//----------------------------
	// implementation of CStateSendInit
	// 
	CStateSendInit::CStateSendInit(UIChatFileElement * pUIElem)
		:CFTStateSendBase(pUIElem)
	{
		m_bButtonIsLink[Button_General] = TRUE;
	}

	CStateSendInit::~CStateSendInit()
	{
	}

	void CStateSendInit::_CalcProgressSize( const CPoint& ptOffset )
	{
		
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		if(pResource->GetChatDisplayType() == CHAT_BUBBLE)
		{
			m_rcProgress.X = m_rcFileIcon.X + (REAL)m_nProgressbarLeftEdge;
			m_rcProgress.Y = (REAL)(m_rcFileIcon.GetBottom() - (_GetBubbleImage(TRUE, 6)->GetHeight() - _GetYourProgressbarImage(0)->GetHeight()) / 2 - _GetYourProgressbarImage(0)->GetHeight());
			m_rcProgress.Width =  m_rcFileIcon.Width -((REAL)m_nProgressbarLeftEdge + (REAL)m_nProgressbarRightEdge);
			m_rcProgress.Height = (REAL)_GetYourProgressbarImage(0)->GetHeight();
		}
		else
		{
			CFTState::_CalcProgressSize(ptOffset);
		}
	}

	void CStateSendInit::_CalcButtonsSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		Image* pImage = pResource->GetCancelSendImage();

		m_rcButton[Button_General].X = m_rcFileIcon.GetRight() - (REAL)m_nButtonRightEdge - pImage->GetWidth();
		m_rcButton[Button_General].Y = m_rcFileIcon.GetBottom() - (REAL)(_GetBubbleImage(TRUE, 6)->GetHeight() - pImage->GetHeight()) / 2 - pImage->GetHeight();
		m_rcButton[Button_General].Width = pImage->GetWidth();
		m_rcButton[Button_General].Height = pImage->GetHeight();
	}

	BOOL CStateSendInit::_DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset )
	{
		RectF rcDraw = m_rcButton[Button_General];
		rcDraw.Offset(ptGdiPOffset);
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		Image *pImage = pResource->GetCancelSendImage();

		pGraph->DrawImage(pImage, rcDraw);

		return TRUE;
	}

	void CStateSendInit::_OnButtonClick()
	{
		m_pUIChatFileElement->GetElementResource()->CancelFileTransfer(m_pUIChatFileElement->GetChatFileItem());
	}

	BOOL CStateSendInit::_DrawProgressBar( Graphics *pGraph, RectF& rcBar )
	{
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		Image* pProgress0 = pResource->GetMyProgressBarImage(0);
		Image* pProgress1 = pResource->GetMyProgressBarImage(1);

		if (pProgress0 == NULL || pProgress1 == NULL)
		{
			return FALSE;
		}

		int nPercent = m_pUIChatFileElement->GetProgress();

		InterpolationMode interpolationMode = pGraph->GetInterpolationMode();
		PixelOffsetMode pixelOffsetMode = pGraph->GetPixelOffsetMode();
		pGraph->SetInterpolationMode(InterpolationModeNearestNeighbor);
		pGraph->SetPixelOffsetMode(PixelOffsetModeHalf);
		CRect rcProgressBar(0, 0, 0, 0);
		rcProgressBar.bottom = rcBar.Y + rcBar.Height;
		rcProgressBar.top = rcProgressBar.bottom - pProgress1->GetHeight();
		rcProgressBar.left = rcBar.X;
		rcProgressBar.right = rcBar.X + rcBar.Width;

		//draw bg  (1,2,3)
		pGraph->DrawImage(pProgress1, rcProgressBar.left, rcProgressBar.top, rcProgressBar.Width(), pProgress1->GetHeight());

		pGraph->SetInterpolationMode(interpolationMode);
		pGraph->SetPixelOffsetMode(pixelOffsetMode);
		return TRUE;
	}

	//------------------------------------------
	// implementation of CStateSendProgress
	// 
	CStateSendProgress::CStateSendProgress(UIChatFileElement * pUIElem)
		: CFTStateSendBase(pUIElem)
	{
		m_bButtonIsLink[Button_General] = TRUE;
	}

	CStateSendProgress::~CStateSendProgress()
	{
	}

	void CStateSendProgress::_OnButtonClick()
	{
		m_pUIChatFileElement->GetElementResource()->CancelFileTransfer(m_pUIChatFileElement->GetChatFileItem());
		SetFocusToChatEdit();
	}

	void CStateSendProgress::_CalcProgressSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		int nDisplayType = pResource->GetChatDisplayType();
		if (CHAT_PLAIN == nDisplayType)
		{
			m_clrButtonText[Button_General] = GetCurrentLayout(nDisplayType).common().clr_text_link;
			m_strButtonText[Button_General] = LoadStringFromResource(IDS_CHAT_FILE_CANCEL);
			m_fontStyleButtonText[Button_General] = FontStyleUnderline;
			m_strProgressExtraStatus = LoadStringFromResource(IDS_CHAT_FILE_SEND_STATUS);
			m_bShowDivider = TRUE;
		}

		if(pResource->GetChatDisplayType() == CHAT_BUBBLE)
		{
			m_rcProgress.X = m_rcFileIcon.X + (REAL)m_nProgressbarLeftEdge;
			m_rcProgress.Y = (REAL)(m_rcFileIcon.GetBottom() - (_GetBubbleImage(TRUE, 6)->GetHeight() - _GetYourProgressbarImage(0)->GetHeight()) / 2 - _GetYourProgressbarImage(0)->GetHeight());
			m_rcProgress.Width =  m_rcFileIcon.Width -((REAL)m_nProgressbarLeftEdge + (REAL)m_nProgressbarRightEdge);
			m_rcProgress.Height = (REAL)_GetYourProgressbarImage(0)->GetHeight();
		}
		else
		{
			CFTState::_CalcProgressSize(ptOffset);
		}
	}

	void CStateSendProgress::_CalcButtonsSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();
		Image* pImage = pResource->GetCancelSendImage();

		m_rcButton[Button_General].X = m_rcFileIcon.GetRight() - (REAL)m_nButtonRightEdge - pImage->GetWidth();
		m_rcButton[Button_General].Y = m_rcFileIcon.GetBottom() - (REAL)(_GetBubbleImage(TRUE, 6)->GetHeight() - pImage->GetHeight()) / 2 - pImage->GetHeight();
		m_rcButton[Button_General].Width = pImage->GetWidth();
		m_rcButton[Button_General].Height = pImage->GetHeight();
	}

	BOOL CStateSendProgress::_DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset )
	{
		RectF rcDraw = m_rcButton[Button_General];
		rcDraw.Offset(ptGdiPOffset);
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		Image *pImage = pResource->GetCancelSendImage();

		pGraph->DrawImage(pImage, rcDraw);

		return TRUE;
	}

	BOOL CStateSendProgress::_DrawProgressBar( Graphics *pGraph, RectF& rcBar )
	{
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();

		Image* pProgress0 = pResource->GetMyProgressBarImage(0);
		Image* pProgress1 = pResource->GetMyProgressBarImage(1);

		if (pProgress0 == NULL || pProgress1 == NULL)
		{
			return FALSE;
		}

		int nPercent = m_pUIChatFileElement->GetProgress();

		InterpolationMode interpolationMode = pGraph->GetInterpolationMode();
		PixelOffsetMode pixelOffsetMode = pGraph->GetPixelOffsetMode();
		pGraph->SetInterpolationMode(InterpolationModeNearestNeighbor);
		pGraph->SetPixelOffsetMode(PixelOffsetModeHalf);
		CRect rcProgressBar(0, 0, 0, 0);
		rcProgressBar.bottom = rcBar.Y + rcBar.Height;
		rcProgressBar.top = rcProgressBar.bottom - pProgress1->GetHeight();
		rcProgressBar.left = rcBar.X;
		rcProgressBar.right = rcBar.X + rcBar.Width;

		//draw bg  (1,2,3)
		pGraph->DrawImage(pProgress1, rcProgressBar.left, rcProgressBar.top, rcProgressBar.Width(), pProgress1->GetHeight());

		if (nPercent > 0)
		{
			int nWidth = rcProgressBar.Width();
			int nStepLength = min(nWidth * nPercent / 100, nWidth);
			if (nStepLength > 0)
			{
				pGraph->DrawImage(pProgress0, 
					rcProgressBar.left, rcProgressBar.top, nStepLength, rcProgressBar.Height());
			}
		}
		pGraph->SetInterpolationMode(interpolationMode);
		pGraph->SetPixelOffsetMode(pixelOffsetMode);
		return TRUE;
	}

		//-------------------------------------------------
	// implementation of CStateSendComplete
	// 
	CStateSendComplete::CStateSendComplete(UIChatFileElement *pUIElem):CFTStateSendBase(pUIElem)
	{
		m_strButtonText[Button_General] = LoadStringFromResource(IDS_CHAT_FILE_SEND_COMPLETE);
	}

	CStateSendComplete::~CStateSendComplete()
	{
	}

	void CStateSendComplete::_CalcProgressSize( const CPoint& ptOffset )
	{
		m_rcProgress.Width = 0.0f;
		m_rcProgress.Height = 0.0f;
	}

	void CStateSendComplete::_CalcButtonsSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();

		CSize szBound = _CalcTextSize(m_strButtonText[Button_General], ptOffset);
		m_rcButton[Button_General].Width = (REAL)szBound.cx ;
		m_rcButton[Button_General].Height = (REAL)szBound.cy ;
		m_rcButton[Button_General].X = m_rcFileIcon.X + (m_rcFileIcon.Width - _GetBubbleCornerUnvisibleWidth() - m_rcButton[Button_General].Width) / 2;
		m_rcButton[Button_General].Y = m_rcFileIcon.GetBottom() - m_rcButton[Button_General].Height - 
			(_GetBubbleImage(TRUE, 6)->GetHeight() - m_rcButton[Button_General].Height) / 2 + 2;	
	}

	BOOL CStateSendComplete::_DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset )
	{
		RectF rcDraw = m_rcButton[Button_General];
		rcDraw.Offset(ptGdiPOffset);

		////draw text
		CRect rcText(rcDraw.X, rcDraw.Y, rcDraw.GetRight(), rcDraw.GetBottom());
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();
		CRect rcClient = pResource->GetViewRect();
		DrawTextToDest2(pGraph, m_strButtonText[Button_General], &rcClient, &rcText, g_defaultFontFaceName,
			8, 
			m_alignmentButton[Button_General], m_fontStyleButtonText[Button_General], m_clrButtonText[Button_General]);

		return TRUE;
	}

	//------------------------------------------
	// implementation of CStateSendError
	// 
	CStateSendError::CStateSendError(UIChatFileElement *pUIElem):CFTStateSendBase(pUIElem)
	{
		//m_strButtonText = LoadStringFromResource(XXX)
		m_strButtonText[Button_General] = LoadStringFromResource(IDS_CHAT_FILE_SEND_ERROR);// TEXT("Transfer failed!");
	}

	CStateSendError::~CStateSendError()
	{
	}

	void CStateSendError::_CalcProgressSize( const CPoint& ptOffset )
	{
		m_rcProgress.Width = 0.0f;
		m_rcProgress.Height = 0.0f;
	}

	void CStateSendError::_CalcButtonsSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();

		CSize szBound = _CalcTextSize(m_strButtonText[Button_General], ptOffset);
		m_rcButton[Button_General].Width = (REAL)szBound.cx ;
		m_rcButton[Button_General].Height = (REAL)szBound.cy ;
		m_rcButton[Button_General].X = m_rcFileIcon.X + (m_rcFileIcon.Width - _GetBubbleCornerUnvisibleWidth() - m_rcButton[Button_General].Width) / 2;
		m_rcButton[Button_General].Y = m_rcFileIcon.GetBottom() - m_rcButton[Button_General].Height - 
			(_GetBubbleImage(TRUE, 6)->GetHeight() - m_rcButton[Button_General].Height) / 2 + 2;	
	}

	BOOL CStateSendError::_DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset )
	{
		RectF rcDraw = m_rcButton[Button_General];
		rcDraw.Offset(ptGdiPOffset);

		////draw text
		CRect rcText(rcDraw.X, rcDraw.Y, rcDraw.GetRight(), rcDraw.GetBottom());
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();
		CRect rcClient = pResource->GetViewRect();
		DrawTextToDest2(pGraph, m_strButtonText[Button_General], &rcClient, &rcText, g_defaultFontFaceName,
			8, 
			m_alignmentButton[Button_General], m_fontStyleButtonText[Button_General], m_clrButtonText[Button_General]);


		return TRUE;
	}


	//------------------------------------------
	// implementation of CStateSendCancel
	// 
	CStateSendCancel::CStateSendCancel(UIChatFileElement *pUIElem):CFTStateSendBase(pUIElem)
	{
		m_strButtonText[Button_General] = LoadStringFromResource(IDS_CHAT_FILE_SEND_CANCELED);
	}

	CStateSendCancel::~CStateSendCancel()
	{
	}

	void CStateSendCancel::_CalcProgressSize( const CPoint& ptOffset )
	{
		m_rcProgress.Width = 0.0f;
		m_rcProgress.Height = 0.0f;
	}

	void CStateSendCancel::_CalcButtonsSize( const CPoint& ptOffset )
	{
		IUIElementResouce* pResource =  m_pUIChatFileElement->GetElementResource();

		CSize szBound = _CalcTextSize(m_strButtonText[Button_General], ptOffset);
		m_rcButton[Button_General].Width = (REAL)szBound.cx ;
		m_rcButton[Button_General].Height = (REAL)szBound.cy ;
		m_rcButton[Button_General].X = m_rcFileIcon.X + (m_rcFileIcon.Width - _GetBubbleCornerUnvisibleWidth() - m_rcButton[Button_General].Width) / 2;
		m_rcButton[Button_General].Y = m_rcFileIcon.GetBottom() - m_rcButton[Button_General].Height - 
			(_GetBubbleImage(TRUE, 6)->GetHeight() - m_rcButton[Button_General].Height) / 2 + 2;	
	}

	BOOL CStateSendCancel::_DrawButton( Graphics *pGraph, const PointF& ptGdiPOffset )
	{
		RectF rcDraw = m_rcButton[Button_General];
		rcDraw.Offset(ptGdiPOffset);

		////draw text
		CRect rcText(rcDraw.X, rcDraw.Y, rcDraw.GetRight(), rcDraw.GetBottom());
		IUIElementResouce* pResource = m_pUIChatFileElement->GetElementResource();
		CRect rcClient = pResource->GetViewRect();
		DrawTextToDest2(pGraph, m_strButtonText[Button_General], &rcClient, &rcText, g_defaultFontFaceName,
			8, 
			m_alignmentButton[Button_General], m_fontStyleButtonText[Button_General], m_clrButtonText[Button_General]);
		

		return TRUE;
	}


}
